;(function($, window, undefined){
	$.fn.plate = function(opts) {
		var defaults = {
			animationType : 'invers', 	        		//(+)ТИП АНИМАЦИИ//advance(вручную)//custom//center-middle//corners//oval//in-corner//invers
			count : 'auto',								//(+)КОЛИЧЕСТВО СЕКТОРОВ АНИМАЦИИ//ЗНАЧЕНИЯ auto, цифра
			defaultSectorWidth : 25,					//(+)ШИРИНА СЕКТОРА АНИМАЦИИ ПО УМОЛЧАНИЮ
			speedShow : 300,							//(+)СКОРОСТЬ АНИМАЦИИ ПОКАЗА//
			rangeShow : 25,								//(+)РАЗБРОС АНИМАЦИИ ПОКАЗА//
			speedHide : 300,							//(+)СКОРОСТЬ АНИМАЦИИ СКРЫТИЯ//
			rangeHide : 25,								//(+)РАЗБРОС АНИМАЦИИ СКРЫТИЯ//
			boxClass : '.plate-item',					//(+)КЛАСС КОНТЕЙНЕРОВ КАРТИНОК//
			innerClass : '.plate-item',					//(+)КЛАСС ПОИСКА ЭЛЕМЕНТОВ ПЛИТКИ//
			eventOpen : 'mouseenter',					//(+)СОБЫТИЕ ОТКРЫТИЯ//
			eventClose : 'mouseleave',					//(+)СОБЫТИЕ СКРЫТИЯ//
			sectorAlign : 'middle',                    	//(+)ПОЗИЦИОНИРОВАНИЕ СЕКТОРОВ//ЗНАЧЕНИЯ: top, bottom, middle
			animateCenter : 'center',                  	//(+)ЦЕНТР АНИМАЦИИ//ЗНАЧЕНИЯЖ left, right, center
			animateParametersShow : {
				opacity : 0,
				height : 0,
				width : 'hide'
			},		
			animateParametersHide : {
				opacity : 1,
				height : '100%',
				width : 'show'
			},											//(+)ТИП АНИМИРУЕМЫХ ПАРАМЕТРОВ//
			backgroundType : 'image',	 				//(+)ТИП ФОНА(КАРТИНКА ИЛИ ПРОЗРАЧНАЯ ЗАЛИВКА)// ЗНАЧЕНИЯ: 'image', 'opacity'
			inversType : 'outer',						//(+)ТИП ИНВЕРСИОННОЙ АНИМАЦИИ//ЗНАЧЕНИЯ: 'inner', 'outer', 'none'
			inversSide : 'tr-lb', 						//(+)КРАЯ НАЧАЛА ИНВЕРСИОННОЙ АНИМАЦИИ//ЗНАЧЕНИЯ: 'tr-lb', 'tl-rb'
			backgroundColor : 'rgba(0, 0, 0, 0.5)',     //(+)ЦВЕТ ПРОЗРАЧНОГО ФОНА// используется если тип фона задан как прозрачный без картинки
		};
		
		var plate = {
			active : function (){
				$(this).addClass('active');
			},
		
			inactive : function (){
				$(this).removeClass('active');
			},
		
			builder : function (element, defaults){	
				var width = $(element).find(defaults.boxClass).width();			
				var perWidth = width/defaults.count/width*100;

				$(element).find(defaults.boxClass).append("<div class='animator'></div>");
				$('.animator').css({"text-align" : defaults.animateCenter})
				$('.animator').append("<div class='vertical'></div>");		
				
				for (var i = 0; i< defaults.count; i++){
					$('.animator').append("<div class='sector'></div>");
				}
				
				$('.sector').css({"width" : perWidth+"%"});
				
				var animators = $('.animator');
				
				for (var i = 0; i < animators.length; i++){
					var background = $(animators[i]).parent().css("background-image");

					var sectors = $(animators[i]).children(".sector");
					
					switch (defaults.backgroundType) {
						case 'image':
							$(animators[i]).children(".sector").css({"background-image" : background, "vertical-align" : defaults.sectorAlign});
						break;
						case 'opacity':
							$(animators[i]).children(".sector").css({"background" : defaults.backgroundColor, "vertical-align" : defaults.sectorAlign});
						break;
						default:
							alert( 'Тип фона указан неверно!' );
						break;
					}
									
					/*if(defaults.invers){*/
						switch (defaults.inversSide) {
							case 'tr-lb':
								for (var k = 0; k < sectors.length; k++){
									if(k < Math.ceil(sectors.length/2)){$(sectors[k]).css({"vertical-align" : "top"});}else{$(sectors[k]).css({"vertical-align" : "bottom"});}
								}
							break;
							case 'tl-rb':
								for (var k = 0; k < sectors.length; k++){
									if(k < Math.ceil(sectors.length/2)){$(sectors[k]).css({"vertical-align" : "bottom"});}else{$(sectors[k]).css({"vertical-align" : "top"});}
								}
							break;
							default:
								for (var k = 0; k < sectors.length; k++){
									if(k < Math.ceil(sectors.length/2)){$(sectors[k]).css({"vertical-align" : defaults.sectorAlign});}else{$(sectors[k]).css({"vertical-align" : defaults.sectorAlign});}
								}
							break;
						}
					/*}*/
			
					for (var j = 0; j < sectors.length; j++){							
						var position = j * perWidth * ((sectors.length)/(sectors.length-1)) + "%";
						$(sectors[j]).css({"background-position" : position+ " top"});
					}
				}
			},
			
			showPlate : function (){
				var defaults = $.fn.plate.defaults;
			
				$(this).unbind(defaults.eventOpen, plate.showPlate);
				$(this).unbind(defaults.eventClose, plate.hidePlate);
				
				var callback = function func(){
					$(this).parent().parent().bind(defaults.eventClose, plate.hidePlate);
					if(!$(this).parent().parent().hasClass('active')){$(this).parent().parent().trigger(defaults.eventClose);}
				}

				var sectors = $(this).find(".sector");
				var delay = 0;

				switch (defaults.inversType) {
					case 'inner':
						for(var i = 1; i<=sectors.length; i++){
							if(i == sectors.length){
								$(sectors[sectors.length-i]).delay(delay).animate(defaults.animateParametersShow, defaults.speedShow, callback);
							}else{
								$(sectors[sectors.length-i]).delay(delay).animate(defaults.animateParametersShow, defaults.speedShow);
								$(sectors[i-1]).delay(delay).animate(defaults.animateParametersShow, defaults.speedShow);
							}
								
							delay += defaults.rangeShow;
						}
					break;
					case 'outer':
						for(var i = 1; i<=sectors.length; i++){
							if(i == sectors.length){
								$(sectors[sectors.length-i]).delay(delay).animate(defaults.animateParametersShow, defaults.speedShow, callback);
							}else{
								$(sectors[sectors.length-i]).delay(delay).animate(defaults.animateParametersShow, defaults.speedShow);
								$(sectors[i-1]).delay(delay).animate(defaults.animateParametersShow, defaults.speedShow);
							}
								
							delay += defaults.rangeShow;
						}
					break;
					case 'none':
						for(var i = 1; i<=sectors['length']; i++){
							if(i == sectors['length']){$(sectors[i-1]).delay(delay).animate(defaults.animateParametersShow, defaults.speedHide, callback);}
							
							$(sectors[sectors['length']-i]).delay(delay).animate(defaults.animateParametersShow, defaults.speedShow);
							//$(sectors[i-1]).delay(delay).animate({ height : 0 }, defaults.speedShow);
															
							delay += defaults.rangeShow;
						}
					break;	
					default:
						alert( 'Тип фона указан неверно!' );
					break;
				}	
			},

			hidePlate : function hideElement(){	
				var defaults = $.fn.plate.defaults;

				$(this).unbind(defaults.eventOpen, plate.showPlate);
				$(this).unbind(defaults.eventClose, plate.hidePlate);

				var callback = function func(){
					$(this).parent().parent().bind(defaults.eventOpen, plate.showPlate);
					if($(this).parent().parent().hasClass('active')){$(this).parent().parent().trigger(defaults.eventOpen);}
				}
				
				var sectors = $(this).find(".sector");
				var delay = 0;
			
				switch (defaults.inversType) {
					case 'inner':
						for(var i = 0; i<=Math.ceil(sectors.length/2); i++){
							if(i == Math.ceil(sectors.length/2)){
								$(sectors[i]).delay(delay).animate(defaults.animateParametersHide, defaults.speedHide, callback);
							}else{
								$(sectors[sectors.length-i]).delay(delay).animate(defaults.animateParametersHide, defaults.speedHide);
								$(sectors[i]).delay(delay).animate(defaults.animateParametersHide, defaults.speedHide);
							}
							
							delay += defaults.rangeHide;
						}
					break;
					case 'outer':
						for(var i = 0; i<=Math.ceil(sectors.length/2)+1; i++){
							if(i == Math.ceil(sectors.length/2)+1){
								$(sectors[i]).delay(delay).animate(defaults.animateParametersHide, defaults.speedHide, callback);
							}else{
								$(sectors[Math.ceil(sectors.length/2)+i]).delay(delay).animate(defaults.animateParametersHide, defaults.speedHide);
								$(sectors[Math.ceil(sectors.length/2)-i]).delay(delay).animate(defaults.animateParametersHide, defaults.speedHide);
							}
							
							delay += defaults.rangeHide;
						}
					break;
					case 'none':
						for(var i = 0; i<=sectors['length']; i++){
							if(i == sectors['length']){$(sectors[i-1]).delay(delay).animate(defaults.animateParametersHide, defaults.speedHide, callback);}
							$(sectors[i]).delay(delay).animate(defaults.animateParametersHide, defaults.speedHide);
														
							delay += defaults.rangeHide;
						}
					break;
					default:
						alert( 'Тип фона указан неверно!' );
					break;
				}			
			}
		};
		
		// дополните стандартные опции пользовательскими
		var options = $.extend(defaults, opts, plate || {});

		return this.each(function(){ // jQuery chainability
			if(defaults.innerClass !== ''){$(this).find(defaults.innerClass).addClass(defaults.boxClass.replace('.', ''));
			}else{$(this).children().addClass(defaults.boxClass.replace('.', ''));}

			if(defaults.defaultSectorWidth == 'auto'){defaults.defaultSectorWidth = Math.floor($(this).children().width()*0.05);}
			if(defaults.count == 'auto'){defaults.count = Math.floor($(this).children().width()/defaults.defaultSectorWidth);}
			
			switch (defaults.animationType) {
				case 'custom':
					defaults.sectorAlign = 'top';
					defaults.animateCenter = 'left';
					defaults.animateParametersShow = {opacity : 0};
					defaults.animateParametersHide = {opacity : 1};
				break;
				case 'center-middle':
					defaults.sectorAlign = 'middle';
					defaults.animateCenter = 'center';
					defaults.animateParametersShow = {height : 0, opacity : 0};
					defaults.animateParametersHide = {height : '100.3%', opacity : 1};
					defaults.inversType = 'outer';
				break;
				case 'corners':
					defaults.sectorAlign = 'top';
					defaults.animateCenter = 'center';
					defaults.animateParametersShow = {height : 0};
					defaults.animateParametersHide = {height : '100%'};
					defaults.inversType = 'inner';
					defaults.inversSide = 'none';
				break;
				case 'oval':
					defaults.sectorAlign = 'bottom';
					defaults.animateCenter = 'center';
					defaults.animateParametersShow = {height : 0, width : 'hide', opacity : 0};
					defaults.animateParametersHide = {height : '100%', width : 'show', opacity : 1};
					defaults.inversType = 'inner';
					defaults.inversSide = 'none';
				break;
				case 'in-corner':
					defaults.sectorAlign = 'bottom';
					defaults.animateCenter = 'right';
					defaults.animateParametersShow = {height : 0, width : 'hide'};
					defaults.animateParametersHide = {height : '100%', width : 'show'};
					defaults.inversType = 'none';
					defaults.inversSide = 'none';
				break;
				case 'invers':
					defaults.sectorAlign = 'bottom';
					defaults.animateCenter = 'center';
					defaults.animateParametersShow = {height : 0, opacity : 0};
					defaults.animateParametersHide = {height : '100%', opacity : 1};
					defaults.inversType = 'inner';
					defaults.inversSide = 'tr-lb';
				break;
				default:
				break;
			}
			
			$.fn.plate.defaults = defaults;
		
			$(this).find(defaults.boxClass).bind(defaults.eventOpen, plate.showPlate);
			
			$(this).find(defaults.boxClass).bind(defaults.eventOpen, plate.active);			
			$(this).find(defaults.boxClass).bind(defaults.eventClose, plate.inactive);	
			
			plate.builder(this, defaults);
		});
	}	
})(jQuery, window);